=== Modules/Adapters/QtAdapters/src/CMakeLists.txt ===
#
# Copyright (C) 2005-2017 Centre National d'Etudes Spatiales (CNES)
#
# This file is part of Orfeo Toolbox
#
#     https://www.orfeo-toolbox.org/
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

set( OTBQtAdapters_SRC
  otbQtAdapters.cxx
  )

set( OTBQtAdapters_HEADERS_MOC
  # otbQtAdapters.h
  )

add_to_qt_i18n_sources( ${OTBQtAdapters_SRCS} )
add_to_qt_i18n_headers( "../include" ${OTBQtAdapters_SRCS} )

qt5_wrap_cpp( OTBQtAdapters_SRC_MOC ${OTBQtAdapters_HEADERS_MOC} )

add_library( OTBQtAdapters ${OTBQtAdapters_SRC} ${OTBQtAdapters_SRC_MOC})

target_link_libraries( OTBQtAdapters 
  ${OTBQt_LIBRARIES}
  )

otb_module_target( OTBQtAdapters )
