=== debian/changelog ===
otb (6.6.0+dfsg-1build1) cosmic; urgency=medium

  * Rebuild against new gdal PIC enabled.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 29 Jun 2018 15:11:48 +0200

otb (6.6.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Update symbols for amd64.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 21 Jun 2018 16:42:26 +0200

otb (6.6.0~rc4+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Don't explicitly enable OpenMP, enabled via Shark dependency.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 12 Jun 2018 10:02:47 +0200

otb (6.6.0~rc3+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Update symbols for amd64 & i386.
  * Add manpages for new executables.
  * Add patch to fix spelling errors.
  * Drop spelling-errors.patch, applied upstream.
  * Add lintian override for manpage-has-errors-from-man.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 08 Jun 2018 20:34:54 +0200

otb (6.6.0~rc2+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Add manpages for new executables.
  * Generate control file from control.in template.
  * Drop patches, applied upstream.
  * Drop unused spelling-error-in-binary override.
  * Re-enable libshark support, support for Shark 3.1.4 restored.
  * Enable OpenMP, Shark has it enabled as well.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 07 Jun 2018 17:47:12 +0200

otb (6.6.0~rc1+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate.
  * Drop patches, included upstream.
  * Disable libshark support, causes FTBFS, see:
    https://gitlab.orfeo-toolbox.org/orfeotoolbox/otb/issues/1592
  * Add upstream patch to fix QGIS wrapper FTBFS.
  * Use Qt5 for Monteverdi.
    (closes: #875083)
  * Add patch to support libqwt provided by libqwt-qt5-dev.
  * Add library package for libOTBLearningBase.
  * Add otb-qgis package for otbQgisDescriptor application.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 26 May 2018 16:59:49 +0200

otb (6.4.0+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.1.4, no changes.
  * Add upstream patch to fix FTBFS with GDAL 2.3.0.
    (closes: #896837)

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 27 Apr 2018 18:06:58 +0200
